package es.rediris.forja.jleon.arrivalert;

import android.content.Context;


public abstract class Alerta implements Comparable<Alerta>, IListaElementos {
	
	public static final int ALERTA_IM = 1;
	protected int id;
	protected String nombre;
	
	
	protected Alerta(int id, String nombre) {
		this.id = id;
		this.nombre = nombre;
	}
	
	
	public int getId() {
		return id;
	}
	
	public void setId(int id) {
		this.id = id;
	}
	
	public String getNombre() {
		return nombre;
	}
	
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	
	
	@Override
	public int compareTo(Alerta a) {
		return this.nombre.compareTo(a.nombre); 
	}
	
	@Override
	public String getElementoPrincipal() {
		return this.getNombre();
	}
	
	public boolean operar(Context c, boolean deshabilitado) {
		if(deshabilitado)
			return operarDeshabilitado(c);
		return operarHabilitado(c);
	}
	
	/** IlistaElementos **/
	
			  public abstract int     getAlertarID();
    @Override public abstract String  getElementoSecundario();
	@Override public abstract int     getElementoImagenID();
	          public abstract boolean operarHabilitado(Context c);
	          public abstract boolean operarDeshabilitado(Context c);
	
}
