package es.rediris.forja.jleon.arrivalert;


import java.util.ArrayList;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class BDUbicacion extends SQLiteOpenHelper {
		
	public BDUbicacion(Context context) {	
		super(context, "bd_ubicacion", null, 2);	
	}
	
	// SQLiteOpenHelper methods
	
	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL("CREATE TABLE lugares ("+	
	                   "_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
	                   "nombre TEXT, descripcion TEXT, direccion TEXT, latitudeE6 INTEGER, longitudeE6 INTEGER)");	
	}	
	
	
	@Override    
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {		
		//actualizacin+eliminacin de tablas
		if(oldVersion == 1) {
			db.execSQL("DROP TABLE lugares");
			onCreate(db);
		}
	}	
	
	
	//Métodos con Lugares
	
	public void insertUbicacion(Ubicacion l) {	
		if(l==null)
			return;
		
		SQLiteDatabase db = getWritableDatabase();		
		String sql = String.format("INSERT INTO lugares VALUES (null, '%s', '%s', '%s', %s, %s)", 
				l.getNombre(), 
				l.getDescripcion(), 
				l.getDireccion(),
				l.getLocation().getLatitudeE6(),
				l.getLocation().getLongitudeE6());
		
		db.execSQL(sql);
		db.close();
	}
	
	public void deleteUbicacion(int id) {	
		if(id < 1)
			return;
		
		SQLiteDatabase db = getWritableDatabase();		
		String sql = String.format("DELETE FROM lugares WHERE _id = %s", id);
		
		db.execSQL(sql);
		db.close();
	}
	
	public void updateUbicacion(Ubicacion l) {	
		if(l==null)
			return;
		
		SQLiteDatabase db = getWritableDatabase();		
		String sql = String.format("UPDATE lugares SET nombre = '%s', descripcion = '%s', direccion = '%s', latitudeE6 = %s, longitudeE6 = %s WHERE _id = %s", 
				l.getNombre(), 
				l.getDescripcion(),
				l.getDireccion(),
				l.getLocation().getLatitudeE6(),
				l.getLocation().getLongitudeE6(),
				l.getId());
		
		db.execSQL(sql);
		db.close();
	}
	
	public void deleteUbicacion(Ubicacion l) {	
		if(l != null)
		deleteUbicacion(l.getId());
	}
	
	public Ubicacion getUbicacion(int idLugar){
		Ubicacion l = null;		
		SQLiteDatabase db = getReadableDatabase();
		
		String sql = "SELECT _id, nombre, descripcion, direccion, latitudeE6, longitudeE6 FROM lugares WHERE _id = " + idLugar;		
		Cursor cursor = db.rawQuery(sql, null);
				
		// solo una ubicacion
		if (cursor.moveToNext())
			l = new Ubicacion(cursor.getInt(0), 
						  cursor.getString(1),
						  cursor.getString(2),
						  cursor.getString(3),						  
						  cursor.getInt(4),
						  cursor.getInt(5));		
		
		cursor.close();
		db.close();
		
		return l;	
	}
	
	
	public ArrayList<Ubicacion> getAllUbicacion() {
		
		ArrayList<Ubicacion> lugares = new ArrayList<Ubicacion>();
		Ubicacion l = null;		
		SQLiteDatabase db = getReadableDatabase();
		
		String sql = "SELECT _id, nombre, descripcion, direccion, latitudeE6, longitudeE6 FROM lugares ORDER BY nombre ";		
		Cursor cursor = db.rawQuery(sql, null);
				
		// solo una ubicacion
		while (cursor.moveToNext()) {
			l = new Ubicacion(cursor.getInt(0), 
						  cursor.getString(1),
						  cursor.getString(2),
						  cursor.getString(3),						  
						  cursor.getInt(4),
						  cursor.getInt(5));
			
			lugares.add(l);
		}
		
		cursor.close();
		db.close();
		
		return lugares;	
	}
	
}
