package es.rediris.forja.jleon.arrivalert;

import java.util.Calendar;
import java.util.Date;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.TextView;
import android.widget.TimePicker;
import android.widget.Toast;


public class ConfiguraEventoActivity extends Activity implements TimePickerDialog.OnTimeSetListener, DatePickerDialog.OnDateSetListener
{	
	// Variables estáticas
	private Calendar calendar = Calendar.getInstance(); // variable auxiliar para trabajar con fechas
	
	// Atributos
	private Evento  c = null;
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(R.layout.configurevento);
		
		
		// Obtenemos la Evento que hemos de editar desde los extras
		// SIEMPRE NOS TIENEN QUE PASAR ESE ID
		Bundle extras = this.getIntent().getExtras();
		int id = extras == null ? -1 : extras.getInt(Constantes.CTE_EVENTO_ID);
		
		if(id != 0)
		{
			// Modo editar un registro que ya existe en la bd
			BDEvento db = new BDEvento(this);
			this.c = db.getCita(id);
			db.close();
			
			if(this.c != null)
			{
				// Ponemos los valores en los TextView
				((TextView)findViewById(R.id.txtName)).setText(this.c.getNombre());
				((TextView)findViewById(R.id.txtDesc)).setText(this.c.getDescripcion());
				((TextView)findViewById(R.id.txtKmsTarde)).setText(Float.toString(this.c.getKmsTarde()));//TODO
				//((Spinner)findViewById(R.id.txtKmsTarde)).setText(Float.toString(this.c.getKmsTarde()));//TODO
				
				// Obtenemos el nombre del lugar
				if(this.c.getUbicacion() != null)
				{				
					((Button)findViewById(R.id.btSelectPlace)).setText(this.c.getUbicacion().getNombre());
				}				
				
				// Ponemos las fechas en los botones
				RefreshFechas();
			}
		}

		if(this.c == null)
		{
			// nunca debería entrar aquí
			Toast.makeText(this, "Error tab datos: Has de pasarle un id_cita válido", Toast.LENGTH_LONG).show();
		}
	}
	
	// Refresca las fechas en base al objeto Evento
	private void RefreshFechas()
	{
		Button btF  = ((Button)findViewById(R.id.btDate));
		Button btH  = ((Button)findViewById(R.id.btHour));
		Button btFW = ((Button)findViewById(R.id.btDateWarning));
		Button btHW = ((Button)findViewById(R.id.btHourWarning2));
		
		if(this.c == null)
		{
			String s = "[null]";
			btF.setText(s);
			btH.setText(s);
			btFW.setText(s);
			btHW.setText(s);
		}
		else
		{
			btF.setText(this.c.getStrFecha());
			btH.setText(this.c.getStrHour());
			btFW.setText(this.c.getStrFechaWarning());
			btHW.setText(this.c.getStrHourWarning());
		}
		
	}
	
	private void actualizarAlarmas(Evento var1) {
	      Date var2 = new Date();
	      if(var2.after(var1.getFecha())) {
	         var1.setEstado(1);
	         BDEvento.updateCita(this, var1);
	      } else {
	         var1.setEstado(2);
	         BDEvento.updateCita(this, var1);
	         if(var2.after(var1.getFechaAlerta())) {
	            Intent var3 = new Intent(this, ArrivAlertService.class);
	            var3.putExtra("id_cita", var1.getId());
	            this.startService(var3);
	         } else {
	        	 ArrivAlertReceiver.ProgramarAlertas(this, var1);
	         }
	      }

	   }
	
	public void onClickOnSelectPlace(View v)
	{
		Intent i = new Intent(this, UbicacionesActivity.class);
		i.putExtra(Constantes.CTE_MODO, Constantes.CTE_SELECCION);
		startActivityForResult(i, Constantes.CTE_UBICACION);
	}	
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data)
	{
		if(resultCode == RESULT_OK && requestCode == Constantes.CTE_UBICACION)
		{
			String nombre_lugar = data.getExtras().getString(Constantes.CTE_UBICACION_NOMBRE);
			int id_lugar        = data.getExtras().getInt(Constantes.CTE_UBICACION_ID);
			
			// Actualizamos el objeto
			if(this.c.getUbicacion() != null)
			{
				this.c.getUbicacion().setId(id_lugar);
				this.c.getUbicacion().setNombre(nombre_lugar);
			}
			else
			{
				// Todavía no habíamos puesto el lugar en la Evento
				BDUbicacion dbLugares = new BDUbicacion(this);
				Ubicacion l = dbLugares.getUbicacion(id_lugar);
				this.c.setUbicacion(l); 
			}
			
			Button bt = (Button)findViewById(R.id.btSelectPlace);
			if(this.c.getUbicacion() != null)
			{
				// Actualizamos el botón
				bt.setText(this.c.getUbicacion().getNombre());
			}
			else
			{
				bt.setText(getString(R.string.str_empty_place));
			}
			
		}
	}
	
	public void onClickOnDate(View v)
	{
		this.dateWarningSelected = false;
		calendar.setTimeInMillis(this.c.getFecha().getTime());
		int yy = calendar.get(Calendar.YEAR);
		int mm = calendar.get(Calendar.MONTH);
		int dd = calendar.get(Calendar.DAY_OF_MONTH);
		DatePickerDialog d = new DatePickerDialog(this, this, yy, mm, dd);
		d.show();
	}
	
	public void onClickOnHour(View v)
	{
		this.dateWarningSelected = false;
		calendar.setTimeInMillis(this.c.getFecha().getTime());
		int hh = calendar.get(Calendar.HOUR_OF_DAY);
		int mm = calendar.get(Calendar.MINUTE);
		TimePickerDialog d = new TimePickerDialog(this, this, hh, mm, true);
		d.show();
	}
	
	public void onClickOnDateW(View v)
	{
		this.dateWarningSelected = true;
		calendar.setTimeInMillis(this.c.getFechaAlerta().getTime());
		int yy = calendar.get(Calendar.YEAR);
		int mm = calendar.get(Calendar.MONTH);
		int dd = calendar.get(Calendar.DAY_OF_MONTH);
		DatePickerDialog d = new DatePickerDialog(this, this, yy, mm, dd);
		d.show();
	}
	
	public void onClickOnHourW(View v)
	{
		this.dateWarningSelected = true;
		calendar.setTimeInMillis(this.c.getFechaAlerta().getTime());
		int hh = calendar.get(Calendar.HOUR_OF_DAY);
		int mm = calendar.get(Calendar.MINUTE);
		TimePickerDialog d = new TimePickerDialog(this, this, hh, mm, true);
		d.show();
	}
	
	private boolean textIsNull(TextView txt)
	{
		if(txt.getText() == null)
			return true;
		return false;
	}
	
	private String getTextFromTxt(TextView txt)
	{
		if(textIsNull(txt))
			return "";
		else return (String)txt.getText().toString();
	}
	
	public void onClickOnOk(View v)
	{
		// hemos hecho click en el ok
		
		TextView txtName = (TextView)findViewById(R.id.txtName);
		TextView txtDesc = (TextView)findViewById(R.id.txtDesc);
		TextView txtKms  = (TextView)findViewById(R.id.txtKmsTarde);//TODO
		//Spinner txtKms  = (Spinner)findViewById(R.id.txtKmsTarde);//TODO
		
		String name = getTextFromTxt(txtName);
		String desc = getTextFromTxt(txtDesc);
		String kms  = getTextFromTxt(txtKms);//TODO
		//String kms  = ????????(txtKms);//TODO
		
		// Todos los campos han de tener algún valor
		if(name == null || name.equals("") ||
		   kms  == null || kms.equals(""))
		{
			Toast.makeText(this, R.string.str_err_rellenar_todo, Toast.LENGTH_SHORT).show();
			return;
		}
		
		float kmsF = -1.0f;
		try
		{
			kmsF = Float.parseFloat(kms);
		}
		catch(Exception e)
		{
			Toast.makeText(this, R.string.str_err_kms_not_num, Toast.LENGTH_SHORT).show();
			return;
		}
		
		// Comprobamos que la fecha de alerta sea menor que la de la Evento
		if(this.c.getFechaAlerta().after(this.c.getFecha()))
		{
			Toast.makeText(this, R.string.str_err_fechas, Toast.LENGTH_SHORT).show();
			return;
		}
			
		
		// Ponemos los valores correspondientes a nuestro objeto
		// los otros datos ya se han ido editando conforme clickábamos en los botones
		this.c.setNombre(name);
		this.c.setDescripcion(desc);
		this.c.setKmsTarde(kmsF);
		this.actualizarAlarmas(c);
		//TODO importante
		
		
		// Creamos una nueva instancia de nuestra db
		BDEvento db = new BDEvento(this);
		db.updateCita(c); // siempre actualizamos citas en este formulario
		
		// Cerramos la conexión de la base de datos
		db.close();
		
		// Programamos la alarma
		//ReceptorArranque.ProgramarAlarma(this, c);
		//ReceptorArranque.ProgramarAlarmaFechaWarningCita(var0, var1);
		
		// terminamos la tarea
		this.setResult(RESULT_OK);
		this.finish();
	}
	
	// Utils
	
	// Variable auxiliar para saber qué fecha estamos editando
	private boolean dateWarningSelected = false;

	@Override
	public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) 
	{
		Date d;
		if(dateWarningSelected)
		{
			d = this.c.getFechaAlerta();
		}
		else
		{
			d = this.c.getFecha();
		}
		
		calendar.set(year, monthOfYear, dayOfMonth);
		d.setTime(calendar.getTimeInMillis());
		RefreshFechas();
	}

	@Override
	public void onTimeSet(TimePicker view, int hourOfDay, int minute) 
	{
		Date d;
		if(dateWarningSelected)
		{
			d = this.c.getFechaAlerta();
		}
		else
		{
			d = this.c.getFecha();
		}
		
		calendar.set(Calendar.HOUR_OF_DAY, hourOfDay);
		calendar.set(Calendar.MINUTE, minute);
		
		d.setTime(calendar.getTimeInMillis());
		RefreshFechas();		
	}

}
