package es.rediris.forja.jleon.arrivalert;


import android.app.TabActivity;
import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.view.Window;
import android.widget.TabHost;
import android.widget.Toast;


public class EventoActivity extends TabActivity {
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(R.layout.evento); // ponemos el layout
		
	    Resources res = getResources();  // Resource object to get Drawables
	    TabHost tabHost = getTabHost();  // The activity TabHost
	    TabHost.TabSpec spec;            // Resusable TabSpec for each tab
	    Intent intent;                   // Reusable Intent for each tab
	    String tabName;
	    
		// Obtenemos la cita que hemos de editar desde los extras
		// SIEMPRE NOS TIENEN QUE PASAR ESE ID
		Bundle extras = this.getIntent().getExtras();
		int id_cita = extras == null ? -1 : extras.getInt(Constantes.CTE_EVENTO_ID);
		
		if(id_cita <= 0) {
			// Si entra aqui, es un error grave
			Toast.makeText(this, "Error al editar evento: Has de pasarle un identificador de evento vlido", Toast.LENGTH_LONG).show();
			return;
		}
		
		

	    // Create an Intent to launch an Activity for the tab (to be reused)
	    intent = new Intent().setClass(this, ConfiguraEventoActivity.class);
	    intent.putExtra(Constantes.CTE_EVENTO_ID, id_cita);
	    // Initialize a TabSpec for each tab and add it to the TabHost
	    tabName = res.getString(R.string.pestana_evento);
	    spec = tabHost.newTabSpec(tabName).setIndicator(tabName,
	           res.getDrawable(R.drawable.calendarojo_)).setContent(intent);
	    tabHost.addTab(spec);

	    
	    intent  = new Intent().setClass(this, ConfiguraAlertaActivity.class);
	    intent.putExtra(Constantes.CTE_EVENTO_ID, id_cita);
	    tabName = res.getString(R.string.pestana_alerta);
	    spec = tabHost.newTabSpec(tabName).setIndicator(tabName,
	           res.getDrawable(R.drawable.alerta)).setContent(intent);
	    tabHost.addTab(spec);
	    

	   tabHost.setCurrentTab(0);

	}
}
