package es.rediris.forja.jleon.arrivalert;

import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import com.google.android.maps.GeoPoint;
import java.util.ArrayList;
import java.util.Iterator;

 public class LocationListenerArrivAlert implements LocationListener {

   private Context ctxt;
   private GeoPoint gploc;
   private ArrayList<ILocationChangedHandler> listListen;
   private LocationManager locManager;


   public LocationListenerArrivAlert(Context c) {
      this.locManager = (LocationManager)c.getSystemService("location");
      this.ctxt = c;
      this.gploc = null;
   }

   public void activar() {
      this.locManager.requestLocationUpdates("gps", 5000L, 1.0F, this);
      this.locManager.requestLocationUpdates("network", 5000L, 1.0F, this);
   }

   public void addLocationChangedListener(ILocationChangedHandler lhc) {
      if(this.listListen == null) {
         this.listListen = new ArrayList<ILocationChangedHandler>();
      }

      if(!this.listListen.contains(lhc)) {
         this.listListen.add(lhc);
      }

   }

   public void desactivar() {
      this.locManager.removeUpdates(this);
   }

   public Context getContext() {
      return this.ctxt;
   }

   public GeoPoint getLastLocation() {
      return this.gploc;
   }

   public LocationManager getLocationManager() {
      return this.locManager;
   }

   public void onLocationChanged(Location loc) {
      this.gploc = new GeoPoint((int)(1000000.0D * loc.getLatitude()), 
    		                    (int)(1000000.0D * loc.getLongitude()));
      if(this.gploc != null && this.listListen != null) {
         Iterator<ILocationChangedHandler> it = this.listListen.iterator();

         while(it.hasNext()) {
            ((ILocationChangedHandler)it.next()).LocationChanged(this, this.gploc);
         }
      }

   }

   public void onProviderDisabled(String s) {}

   public void onProviderEnabled(String s) {}

   public void onStatusChanged(String s, int i, Bundle b) {}

   public void removeLocationChangedListener(ILocationChangedHandler lch) {
      if(this.listListen != null) {
         this.listListen.remove(lch);
      }

   }
}
