package es.rediris.forja.jleon.arrivalert;

import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.content.Intent;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.CheckBox;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;



public class MapaActivity extends MapActivity 
{	
	
	public static final int MODE_ADD = 1;
	public static final int MODE_ONLY_VIEW = 2;
	
	
    private Localizador mLocationListener; 
    private OverlayArrivAlert overlay;
    private int mode;
    
    public MapView mu;

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);	
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(R.layout.mapa);
		
		//Mapa de Ubicacin de ArrivAlert
        mu = (MapView)findViewById(R.id.mapaUbicacion);
        
        mu.setSatellite(false);
        mu.setTraffic(true);
        
        
        LocationManager mg = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
        this.mLocationListener = new Localizador(mu, mg, this);

        // actualizamos los lugares favoritos que tenemos desde la base de datos       
        this.actualizarLugaresFromDdbb();
        
        
        // Para poder seleccionar un sitio en el mapa
        // podremos decirle a esta actividad que no estamos en modo seleccionar
        Bundle extras = this.getIntent().getExtras();
        this.mode = extras.getInt(Constantes.CTE_MODO);
        if(mode == MODE_ADD)
        {
        	this.overlay = new OverlayArrivAlert(mu);
        	List<Overlay> listOfOverlays = mu.getOverlays();
        	//listOfOverlays.clear();
        	listOfOverlays.add(this.overlay);
        }
        else
        {
        	Button bt = (Button)this.findViewById(R.id.bGuardarUbicacion);
        	bt.setVisibility(View.INVISIBLE);
        }
 
        mu.invalidate();
        
        
        //Visibilidad del mapa
        
        
        CheckBox oCheckBoxSatelite = (CheckBox) findViewById(R.id.checkBox1);    
        
        oCheckBoxSatelite.setOnClickListener(new View.OnClickListener() {
    		@Override
    		public void onClick(View v) {
    			// TODO Auto-generated method stub
    			if(((CheckBox)v).isChecked())  
        			mu.setSatellite(true);
        		else
        			mu.setSatellite(false);    			
    		}
        }); 
        
        
        
    	CheckBox oCheckBoxTrafico = (CheckBox) findViewById(R.id.checkBox2);    
        
    	oCheckBoxTrafico.setOnClickListener(new View.OnClickListener() {
    	    	@Override
    	    	public void onClick(View v) {
    	    			// TODO Auto-generated method stub
    	    			if(((CheckBox)v).isChecked())  
    	        			mu.setTraffic(true);
    	        		else
    	        			mu.setTraffic(false);    			
    	    		}
    	        });
    	
   
        
	}
	
	

	

  	// Métodos del ciclo de vida de la actividad

    @Override    
    protected void onResume() 
    {
          super.onResume();

          // Activamos notificaciones de localización
          this.mLocationListener.activar();
          
          // ponemos como etiqueta el contenido del último sms recibido
          actualizarLugaresFromDdbb();
    }
    
    private void actualizarLugaresFromDdbb()
    {
    	ArrayList<Ubicacion> lugares;
    	BDUbicacion db = new BDUbicacion(this);
    	lugares = db.getAllUbicacion();
    	db.close();
    	
    	this.mLocationListener.addUbicacion(lugares);
    }



    @Override    
    protected void onPause()
    {
          super.onPause();

          // Desactivamos notificaciones para ahorrar batería
          this.mLocationListener.desactivar();            
    }
    
    
	@Override
	protected boolean isRouteDisplayed(){
		return false;
	}
	
	
	// Listener para el botón de OK
	public void onClickOnOk(View v)
	{
		if(this.overlay != null)
		{
			String direccion = this.overlay.getDireccion();
			GeoPoint p = this.overlay.getGeoPoint();
			
			
			// Le pasamos la información a quien nos ha llamado en modo add
			Intent i = new Intent();
			i.putExtra(Constantes.CTE_DIRECCION, direccion);
			i.putExtra(Constantes.CTE_LATITUD,  p.getLatitudeE6());
			i.putExtra(Constantes.CTE_LONGITUD, p.getLongitudeE6());
			this.setResult(RESULT_OK, i);
			this.finish();
		}
	}
}
