package es.rediris.forja.jleon.arrivalert;


import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.view.View;
import android.view.Window;
import android.widget.TextView;
import android.widget.Toast;


public class RegistroAlertaIMActivity extends Activity {
	
	private AlertaIM aim = null;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(R.layout.configuralerta);
		
		/** Traslado de datos **/
		
		Bundle extras = this.getIntent().getExtras();
		int id = extras == null ? -1 : extras.getInt(Constantes.CTE_ALERTA_ID);
		
		if(id != 0) {
			
			/** Reedicin **/
			
			BDAlerta db = new BDAlerta(this);
			this.aim = db.getAccionMail(id);
			db.close();
			
			if(this.aim != null) {
				// Ponemos los valores en los TextView
				((TextView)findViewById(R.id.txtName_edit_action_mail_Form)).setText(this.aim.getNombre());
				((TextView)findViewById(R.id.txtEmailAdd_edit_action_mail_Form)).setText(this.aim.getIMDireccion());
				((TextView)findViewById(R.id.txtEmailSub_edit_action_mail_Form)).setText(this.aim.getIMAsunto());
				((TextView)findViewById(R.id.txtEmailCont_edit_action_mail_Form)).setText(this.aim.getIMContenido());
			}
		}
	}
	
	
	public void onClickOnSelectMail_EditorActionMail(View v) {
		Intent i = new Intent(Intent.ACTION_PICK, ContactsContract.Contacts.CONTENT_URI);
		startActivityForResult(i, 5678);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if(resultCode == RESULT_OK && requestCode == 5678) {
			this.getContactInfo(data);
		}
	}
	
	private boolean textIsNull(TextView txt) {
		if(txt.getText() == null)
			return true;
		return false;
	}
	
	private String getTextFromTxt(TextView txt) {
		if(textIsNull(txt))
			return "";
		else return (String)txt.getText().toString();
	}
	
	public void onClickOnOk_EditorActionMail(View v) {
		
		TextView txtName = (TextView)findViewById(R.id.txtName_edit_action_mail_Form);
		TextView txtAddr = (TextView)findViewById(R.id.txtEmailAdd_edit_action_mail_Form);
		TextView txtSubj = (TextView)findViewById(R.id.txtEmailSub_edit_action_mail_Form);
		TextView txtCont = (TextView)findViewById(R.id.txtEmailCont_edit_action_mail_Form);
		
		String nomb = getTextFromTxt(txtName);
		String dire = getTextFromTxt(txtAddr);
		String asun = getTextFromTxt(txtSubj);
		String cont = getTextFromTxt(txtCont);
		
		/** Ningn campo nulo **/
		
		if(nomb == null || nomb.equals("") || dire == null || dire.equals("") ||
		   
		   asun == null || asun.equals("") || cont == null || cont.equals(""))
		   
		{
			Toast.makeText(this, R.string.str_err_rellenar_todo, Toast.LENGTH_SHORT).show();
			return;
		}
		
		// Creamos una nueva instancia de nuestra db
		BDAlerta db = new BDAlerta(this);
		
		// Si era null, creamos una nueva fila en la bbdd		
		if(this.aim == null) {
			// Creamos una nueva instancia del objeto
			this.aim = new AlertaIM(-1, nomb, dire, asun, cont);
			
			// Insertamos la fila en la base de datos
			db.insertAccion(aim);
		}
		else {
			// sino, actualizamos la que ya teníamos
			aim.setNombre(nomb);
			aim.setIMDireccion(dire);
			aim.setIMAsunto(asun);
			aim.setIMContenido(cont);
			
			// Actualizamos la fila en la base de datos
			db.updateAccion(aim);
		}		
		
		// Cerramos la conexión de la base de datos
		db.close();
		
		// terminamos la tarea
		this.setResult(RESULT_OK);
		this.finish();
	}
	
	
	
	// Utils
	
	protected void getContactInfo(Intent intent) {

	   Cursor cursor =  managedQuery(intent.getData(), null, null, null, null);      
	   if (cursor.moveToNext()) {           
	       String contactId = cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts._ID));
	       
	       // Find Email Addresses
	       Cursor emails = getContentResolver().query(ContactsContract.CommonDataKinds.Email.CONTENT_URI,null,ContactsContract.CommonDataKinds.Email.CONTACT_ID + " = " + contactId,null, null);
	       if (emails.moveToNext()) {
	    	   String emailAddress = emails.getString(emails.getColumnIndex(ContactsContract.CommonDataKinds.Email.DATA));
	    	   ((TextView)findViewById(R.id.txtEmailAdd_edit_action_mail_Form)).setText(emailAddress);
	       }
	       else {
	    	   ((TextView)findViewById(R.id.txtEmailAdd_edit_action_mail_Form)).setText("REGISTRO SIN DIRECCIN");
	       }
	       emails.close();

	       
	   }
       
	   cursor.close();
	}//getContactInfo
}
