package es.rediris.forja.jleon.arrivalert;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Bitmap.Config;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.location.Location;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;


import com.google.android.maps.GeoPoint;


public class Utilidades {
	
	public static double getDistanciaKm(GeoPoint gp1, GeoPoint gp2) {	
		
		float [] distancia = new float[1];
		float redondeo;
		double redondeo2;
		
		double lat1 = ((double)gp1.getLatitudeE6()) / 1e6;
	    double lon1 = ((double)gp1.getLongitudeE6()) / 1e6;
	    double lat2 = ((double)gp2.getLatitudeE6()) / 1e6;
	    double lon2 = ((double)gp2.getLongitudeE6()) / 1e6;
	    
	    Location.distanceBetween(lat1, lon1, lat2, lon2, distancia);
	    
	    //return distancia[0] / 1000;
	    redondeo = distancia[0] / 1000;
	    //redondeo2 = Math.round(redondeo);
	    redondeo2 = Math.round(redondeo*1.e3)/1.e3;
	    
	    return redondeo2;
    }
	
	
	public static Bitmap dibujaBitmap (Drawable dibuja) {
		
	    if (dibuja instanceof BitmapDrawable) {
	        return ((BitmapDrawable)dibuja).getBitmap();
	    }

	    Bitmap bitmap = Bitmap.createBitmap(dibuja.getIntrinsicWidth(), 
	    		dibuja.getIntrinsicHeight(), Config.ARGB_8888);
	    Canvas canvas = new Canvas(bitmap); 
	    dibuja.setBounds(0, 0, canvas.getWidth(), canvas.getHeight());
	    dibuja.draw(canvas);

	    return bitmap;
	}
	
	public static void setIntrinsicSize(Drawable marco) {
        int markerWidth = marco.getIntrinsicWidth();
        int markerHeight = marco.getIntrinsicHeight();
        marco.setBounds(0, 0, markerWidth, markerHeight);
	}
	
	
	/**
	 * Integrada en los permisos del manifiesto
	 * 
	 */
	
    public static boolean existeConexion(Context c) {
    	
        ConnectivityManager conexion =  (ConnectivityManager) c.getSystemService(Context.CONNECTIVITY_SERVICE);

        NetworkInfo wifi   = conexion.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
        NetworkInfo mobile = conexion.getNetworkInfo(ConnectivityManager.TYPE_MOBILE);
                
        return wifi.isConnected() || mobile.isConnected();
    }
    

}
